unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdUDPBase, IdBaseComponent, IdComponent, IdUDPServer,
  IdUDPClient, StdCtrls,   IdStack, IdSocketHandle, Grids, JvExControls,
  JvXPCore, JvXPButtons, JvComCtrls, ExtCtrls, Mask, JvExMask, JvToolEdit,
  JvMaskEdit, IdWhoIsServer, IdTCPServer, IdTelnetServer, winsock,
  JvFormPlacement, JvComponentBase, JvAppStorage, JvAppRegistryStorage,
  JvAppInst, Spin, JvExStdCtrls, JvEdit, JvValidateEdit, jpeg,
  IdCustomTCPServer, Vcl.ComCtrls, Data.DB, DBAccess, MyAccess, MemDS;

type TSTringdynarray = array of String;
type TIPAddr = u_long;
TMACAddr = array[0..5] of char;


type
  TForm1 = class(TForm)
    IdUDPServer1: TIdUDPServer;
    Unit_Grid: TStringGrid;
    JvXPButton1: TJvXPButton;
    JvXPButton2: TJvXPButton;
    Log_Grid: TStringGrid;                 
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    JvAppRegistryStorage1: TJvAppRegistryStorage;
    JvFormStorage1: TJvFormStorage;
    Label14: TLabel;
    JvAppInstances1: TJvAppInstances;
    Label23: TLabel;
    JvXPButton8: TJvXPButton;
    SpinEdit3: TSpinEdit;
    Label4: TLabel;
    SpinEdit4: TSpinEdit;
    Label13: TLabel;
    SpinEdit5: TSpinEdit;
    Label16: TLabel;
    Image1: TImage;
    IdUDPClient1: TIdUDPClient;
    UDP_PORT: TSpinEdit;
    Broadcast_Port: TSpinEdit;
    Label26: TLabel;
    JvXPButton3: TJvXPButton;
//    procedure IdUDPServer1UDPRead(Sender: TObject; AData: TStream;      ABinding: TIdSocketHandle);
    procedure FormShow(Sender: TObject);
    procedure Unit_GridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure WriteTextAligned(Canvas: TCanvas; Rect: TRect; Alignment: TAlignment; Text: string);
    procedure JvXPButton1Click(Sender: TObject);
    procedure JvXPButton2Click(Sender: TObject);
    procedure ADD_LOG( L_IP, L_Port, L_Message : string);
    procedure Log_GridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Unit_GridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    function Explode(const Separator, S: string; Limit: Integer = 0): TStringDynArray;
    procedure FormResize(Sender: TObject);
    procedure IdUDPClient1Status(axSender: TObject;
      const axStatus: TIdStatus; const asStatusText: String);
//    procedure IdUDPServer1UDPRead(Sender: TObject; AData: TBytes;  ABinding: TIdSocketHandle);
    procedure IdUDPServer1UDPRead(AThread: TIdUDPListenerThread; AData: TArray<System.Byte>; ABinding: TIdSocketHandle);
    procedure FormCreate(Sender: TObject);
    procedure JvXPButton8Click(Sender: TObject);
    procedure JvXPButton3Click(Sender: TObject);
  private
    { Private-Deklarationen }
      grdRec:TGridRect;
      defaultport : integer;
      sysupload,sysuploadcheck : boolean;
      sysdata, syscheck : boolean;
      is_rx : boolean;
      Meldung_Byte :  byte;
      Check_Buffer: TArray<System.Byte>;
   public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

    {$EXTERNALSYM SendArp}
    function SendARP (DestIP,SrcIP: TIPAddr; var TMacAddr: TMACAddr; var len: u_long): DWORD stdcall;
    function MACtoString(mac: TMACAddr): string;
    procedure getMacbyHost(host: string; var mac: TMACAddr);
  
implementation

uses UnitModul;



const                                
iphlpapi = 'iphlpapi.dll';
{ Sending an ARP Request }
function sendARP; external iphlpapi name 'SendARP';

{$R *.dfm}

function MACtoString(mac: TMACAddr): string;
begin
        result:= format('%0.2x-%0.2x-%0.2x-%0.2x-%0.2x-%0.2x',
                       [ord(mac[0]),ord(mac[1]),ord(mac[2]),ord(mac[3]),ord(mac[4]),ord(mac[5])]);
end;

procedure getMacbyHost(host: string;var mac: TMACAddr);
var
        l: integer;
begin
        mac[0]:=#0;
        mac[1]:=#0;
        mac[2]:=#0;                    
        mac[3]:=#0;
        mac[4]:=#0;
        mac[5]:=#0;
        l:=sizeof(TMACAddr);
        sendARP(inet_addr(PansiChar(host)),inet_addr(PansiChar('localhost')),mac,l);
end;



procedure TForm1.ADD_LOG( L_IP, L_Port, L_Message : string);
begin
       Log_Grid.RowCount := Log_Grid.RowCount + 1;
       Log_Grid.Cells[0,Log_Grid.RowCount-2] := formatdatetime('hh:nn:ss',now);
       Log_Grid.Cells[1,Log_Grid.RowCount-2] := L_IP;
       Log_Grid.Cells[2,Log_Grid.RowCount-2] := L_Port;
       Log_Grid.Cells[3,Log_Grid.RowCount-2] := L_Message;
       if trunc(Log_Grid.Height / 16) < Log_Grid.RowCount then
          Log_Grid.TopRow := Log_Grid.RowCount - trunc(Log_Grid.Height / 16);
       Log_Grid.Selection:=grdRec;
end;


procedure TForm1.FormShow(Sender: TObject);
begin
        IdUDPServer1.Active := true;
        Unit_Grid.RowCount := 1;

        Log_Grid.RowCount := 1;

        // blaue selektion verbergen
        with grdRec do begin
           Top:=-1;
           Left:=-1;
           Right:=-1;
           Bottom:=-1;
       end;
       Log_Grid.Selection:=grdRec;
       Unit_Grid.Selection:=grdRec;
       sysuploadcheck := false;
end;

procedure TForm1.Unit_GridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
{
        if ACol in [0,1,2] then  begin  // Spalte 1 und 3 zentriert
          WriteTextAligned(TStringGrid(Sender).Canvas, Rect, taCenter, TStringGrid(Sender).Cells[Acol, ARow]);
          exit;
        end;
        if ACol in [3,4] then  begin // Spalte 2 und 4 rechtsbndig
          WriteTextAligned(TStringGrid(Sender).Canvas, Rect, taRightJustify, TStringGrid(Sender).Cells[Acol, ARow]);
          exit;
        end;
        // Alle anderen Spalten linksbndig
        WriteTextAligned(TStringGrid(Sender).Canvas, Rect, taLeftJustify, TStringGrid(Sender).Cells[Acol, ARow]);
}
end;

procedure TForm1.WriteTextAligned(Canvas: TCanvas; Rect: TRect; Alignment: TAlignment; Text: string);
var
  xPos, yPos: integer;
  
begin
xPos := Rect.Left + 2; // Standard verhalten
yPos := Rect.Top + 2; // Standard verhalten
with Canvas do
  begin
  //yPos := Rect.Top + ((Rect.Bottom - Rect.Top - TextHeight(Text)) div 2); // vertikal Zentriert
  case Alignment of // x-Position berechnen
    taRightJustify : // Breite von Rect - Lnge Text - 2 = linker Abstand
      xPos := Rect.Left + (Rect.Right - Rect.Left - TextWidth(Text) - 2);
    taCenter : // Breite von (Rect - Lnge Text - 2) durch 2 = linker Abstand
      xPos := Rect.Left + ((Rect.Right - Rect.Left - TextWidth(Text) - 2) div 2);
    end;
    TextRect(Rect, xPos, yPos, Text);
  end;
end;

procedure TForm1.JvXPButton1Click(Sender: TObject);
var
      x,y,Peer_port : integer;
      Buffer : TArray<System.Byte>;
begin
        for x := 0 to 2 do
           for y := 0 to Unit_Grid.RowCount - 1 do
              Unit_Grid.cells[x, y] := '';
        Unit_Grid.RowCount := 1;

      setlength(Buffer,4);
      IdUDPClient1.Active := false;
      Buffer[0] := ord('B');
      Buffer[1] := ord('R');
      Buffer[2] := ord('C');
      Buffer[3] := ord('A');

      IdUDPClient1.Active := false;
      IdUDPClient1.SendBuffer('255.255.255.255',Broadcast_Port.value, Buffer);
      IdUDPClient1.Active := True;
end;

procedure TForm1.JvXPButton2Click(Sender: TObject);
var
        x,y : integer;
begin
        for x := 0 to 3 do
           for y := 0 to Log_Grid.RowCount - 1 do
              Log_Grid.cells[x, y] := '';
        Log_Grid.RowCount := 1;

end;

procedure TForm1.JvXPButton3Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Log_GridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
{
        // Color
        if ACol in [0] then  begin
          TStringGrid(Sender).Canvas.Font.Color := clgray;
          TStringGrid(Sender).Canvas.Font.Style := [];
        end;
        if ACol in [1,2] then  begin
          TStringGrid(Sender).Canvas.Font.Color := clmaroon;
          TStringGrid(Sender).Canvas.Font.Style := [];
        end;
        if ACol in [3] then  begin
          TStringGrid(Sender).Canvas.Font.Color := clblue;
          TStringGrid(Sender).Canvas.Font.Style := [];
        end;

        if ACol in [2] then  begin  // Spalte 1 und 3 zentriert
          WriteTextAligned(TStringGrid(Sender).Canvas, Rect, taCenter, TStringGrid(Sender).Cells[Acol, ARow]);
          exit;
        end;
        if ACol in [4] then  begin // Spalte 2 und 4 rechtsbndig
          WriteTextAligned(TStringGrid(Sender).Canvas, Rect, taRightJustify, TStringGrid(Sender).Cells[Acol, ARow]);
          exit;
        end;
        // Alle anderen Spalten linksbndig
        WriteTextAligned(TStringGrid(Sender).Canvas, Rect, taLeftJustify, TStringGrid(Sender).Cells[Acol, ARow]);
}
end;

procedure TForm1.Unit_GridMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
      posx, posy, timeout : integer;
      ip_: TSTringdynarray;
      mac: TMACAddr;
begin
      Unit_Grid.MouseToCell(x, y, posx, posy);
      if ( posy > - 1) then begin
         if (Unit_Grid.cells[posx, posy] <> '') then begin
                form2.IP_ADDRESS.Text := '0.0.0.0';
                form2.MASK_ADDRESS.Text := '255.255.255.0';
                form2.GW_ADDRESS.Text := '0.0.0.0';
                ip_ := explode('.', Unit_Grid.cells[0, posy]);
                form2.IP.caption :=  format('%s.%s.%s.%s',[ip_[0],ip_[1],ip_[2],ip_[3]]);
                UDP_Port.Value := strtoint(Unit_Grid.cells[1, posy]);
                sysupload := false;
                is_rx := false;
                IdUDPClient1.Send(form2.IP.caption,UDP_Port.value,'GET');
                timeout := gettickcount + 1000;
                while is_rx = false do begin
                   application.processmessages;
                   if timeout < gettickcount then begin
                       ADD_LOG( form2.IP.caption,inttostr(UDP_Port.value), 'NO RESPONSE FROM '+form2.IP.caption);
                       exit;
                    end;
                end;
                Form2.showmodal;
         end else begin
         end;
      end;
end;


function TForm1.Explode(const Separator, S: string; Limit: Integer = 0): TStringDynArray;
var
  SepLen: Integer;
  F, P: PChar;
  ALen, Index: Integer;
begin

  SetLength(Result, 0);
  if (S = '') or (Limit < 0) then Exit;

  if Separator = '' then
  begin
    SetLength(Result, 1);
    Result[0] := S;
    Exit;
  end;
  SepLen := Length(Separator);
  ALen := Limit;
  SetLength(Result, ALen);

  Index := 0;
  P := PChar(S);
  while P^ <> #0 do
  begin
    F := P;

    P := AnsiStrPos(P, PChar(Separator));
    if (P = nil) or ((Limit > 0) and (Index = Limit - 1)) then P := StrEnd(F);

    if Index >= ALen then
    begin

      Inc(ALen, 5);
      SetLength(Result, ALen);
    end;
    SetString(Result[Index], F, P - F);

    Inc(Index);

    if P^ <> #0 then Inc(P, SepLen);
  end;
  if Index < ALen then SetLength(Result, Index);
end;
procedure TForm1.FormResize(Sender: TObject);               
begin
        Log_Grid.ColWidths[3]:= Log_Grid.Width -
                                Log_Grid.ColWidths[0] -
                                Log_Grid.ColWidths[1] -
                                Log_Grid.ColWidths[2] - 20;
end;


procedure TForm1.IdUDPClient1Status(axSender: TObject;
  const axStatus: TIdStatus; const asStatusText: String);
begin
       ADD_LOG( '','', asStatusText);
end;

procedure TForm1.IdUDPServer1UDPRead(AThread: TIdUDPListenerThread; AData: TArray<System.Byte>; ABinding: TIdSocketHandle);
var
      x, comand : integer;
      i, Code, k, count: Integer;
      found : boolean;
      str, port,ASCII,HEX : string;
      asize,LineLength,offset : integer;
begin
  try
   is_rx := true;
   if (sysupload = false) or (sysuploadcheck = true) then begin

     //  str := DataStringStream.DataString;
       if (AData[0] = ord('G')) and
          (AData[1] = ord('E')) and
          (AData[2] = ord('T')) then begin

          form2.IP_ADDRESS.AddressValues.Value1 := AData[3];
          form2.IP_ADDRESS.AddressValues.Value2 := AData[4];
          form2.IP_ADDRESS.AddressValues.Value3 := AData[5];
          form2.IP_ADDRESS.AddressValues.Value4 := AData[6];

          form2.MASK_ADDRESS.AddressValues.Value1 := AData[7];
          form2.MASK_ADDRESS.AddressValues.Value2 := AData[8];
          form2.MASK_ADDRESS.AddressValues.Value3 := AData[9];
          form2.MASK_ADDRESS.AddressValues.Value4 := AData[10];

          form2.GW_ADDRESS.AddressValues.Value1 := AData[11];
          form2.GW_ADDRESS.AddressValues.Value2 := AData[12];
          form2.GW_ADDRESS.AddressValues.Value3 := AData[13];
          form2.GW_ADDRESS.AddressValues.Value4 := AData[14];

          form2.PORT_TX.Value := (AData[15] shl 8) + AData[16];
          form2.PORT_RX.Value := (AData[17] shl 8) + AData[18];

          form2.MYSQL_PORT.Value := (AData[19] shl 8) + AData[20];

          K := 21;
          form2.MYSQL_URL.Text := '';
          count := Adata[k];
          k := k + 1;
          for i := 1 to count do begin
              form2.MYSQL_URL.Text := trim( form2.MYSQL_URL.Text + chr( AData[k] ));
              k := k + 1;
          end;

          form2.MYSQL_User.Text := '';
          count := Adata[k];
          k := k + 1;
          for i := 1 to count do begin
              form2.MYSQL_User.Text := trim( form2.MYSQL_User.Text + chr( AData[k] ));
              k := k + 1;
          end;

          form2.MYSQL_Pass.Text := '';
          count := Adata[k];
          k := k + 1;
          for i := 1 to count do begin
              form2.MYSQL_Pass.Text := trim( form2.MYSQL_Pass.Text + chr( AData[k] ));
              k := k + 1;
          end;

//          form2.DHCP_ON.Checked := not(AData[k] = 0);
//          form2.IP_ADDRESS.Enabled := not form2.DHCP_ON.Checked;
//          form2.GW_ADDRESS.Enabled := not form2.DHCP_ON.Checked;

          ADD_LOG( abinding.PeerIP,inttostr(abinding.Port), 'GET SETINGS');
       end else if (AData[0] = ord('B')) and
          (AData[1] = ord('R')) and
          (AData[2] = ord('C')) and
          (AData[3] = ord('A')) then begin
             x := 0;
             found := false;
             while x < Unit_Grid.RowCount - 1 do begin
                  if abinding.PeerIP = Unit_Grid.Cells[0,x] then begin
                        found := true;
                        x := Unit_Grid.RowCount;
                  end;
                  inc(x,1);
             end;
             if found = false then begin
                Unit_Grid.Cells[0,Unit_Grid.RowCount-1] := abinding.PeerIP;
                Unit_Grid.Cells[1,Unit_Grid.RowCount-1] := inttostr(abinding.PeerPort);
                Unit_Grid.Cells[2,Unit_Grid.RowCount-1] := inttostr(abinding.Port);
                grdRec.Top := Unit_Grid.RowCount-1;
                grdRec.left := 0;
                grdRec.Bottom := Unit_Grid.RowCount-1;
                grdRec.Right:= 2;
                Unit_Grid.RowCount := Unit_Grid.RowCount + 1;
                Unit_Grid.Selection:=grdRec;
             end;
          ADD_LOG( abinding.PeerIP,inttostr(abinding.Port), 'ONLINE');
       end else if (AData[0] = ord('B')) and
          (AData[1] = ord('R')) and
          (AData[2] = ord('C')) and
          (AData[3] = ord('X')) then begin
          ADD_LOG( abinding.PeerIP,inttostr(abinding.Port), 'SWITCH TO '+inttostr(spinedit3.Value)+'.'+
         inttostr(spinedit4.Value)+'.'+
         inttostr(spinedit5.Value)+'.XXX');
       end else begin
          exit;
       end;
    end else begin
      sysdata := true;
      Meldung_Byte :=  AData[0];
    end;

  finally
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
      Unit_Grid.Height := log_grid.Height;
end;

procedure TForm1.JvXPButton8Click(Sender: TObject);
var
        x,y,Peer_port : integer;
        Buffer : TArray<System.Byte>;
begin
  if MessageDlg('All Units in same Subnet '+
         inttostr(spinedit3.Value)+'.'+
         inttostr(spinedit4.Value)+'.'+
         inttostr(spinedit5.Value)+'.XXX'+
         ' ?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin

        for x := 0 to 2 do
           for y := 0 to Unit_Grid.RowCount - 1 do
              Unit_Grid.cells[x, y] := '';
        Unit_Grid.RowCount := 1;

      setlength(Buffer,7);
      IdUDPClient1.Active := false;
      Buffer[0] := ord('B');
      Buffer[1] := ord('R');
      Buffer[2] := ord('C');
      Buffer[3] := ord('X');
      Buffer[4] := spinedit3.Value;
      Buffer[5] := spinedit4.Value;
      Buffer[6] := spinedit5.Value;
      IdUDPClient1.SendBuffer('255.255.255.255',Broadcast_Port.value, Buffer);
      IdUDPClient1.Active := True;
      ADD_LOG('localhost',inttostr(Broadcast_Port.value), 'SET ALL TO '+
         inttostr(spinedit3.Value)+'.'+
         inttostr(spinedit4.Value)+'.'+
         inttostr(spinedit5.Value)+'.XXX'
         );
    end;
end;

end.


